#include	"mview.h"
#include	"mdir.h"
#include	"window.h"
#include	<HS_wlib.h>
#include	<string.h>

#include	"mbarm3.c"
#include	"mbars3.c"

extern int	FormatstringD(char*, DIRNAME*);
extern int	SendCheck(char*);
extern int	MailExec(WindowID, EventInfo*);
extern int	DirKey(WindowID, EventInfo*);

static void	buttonop(WindowID, EventInfo*);
int	DirExec(WindowID, EventInfo*);
void	DirChange(WindowID, int, int);


static void
buttonop(wp, info)
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[1];
	int	butnum = info->x / BUTTON_V;
  
	switch (butnum) {
	case 0:		/* M */
		receive();
		break;
	case 1:		/* M */
		if (SendFlag) {
			info->KeyCode = 's';
			break;
		} else	return;
	case 2:		/* { */
		info->KeyCode = 'v';
		break;
	case 3:		/* ҏW or ԐM */
		if (SendFlag) {
			info->KeyCode = 'e';
		} else {
			info->KeyCode = 'f';
		}
		break;
	case 4:		/* VK쐬 */
		info->KeyCode = 'w';
		break;
	case 5:		/* Yt */
		if (SendFlag) {
			info->KeyCode = 'x';
			break;
		} else	return;
	case 6:		/* ۑ */
		info->KeyCode = 'c';
		break;
	case 7:		/* ړ */
		info->KeyCode = 'm';
		break;
	case 8:		/* 폜 */
		info->KeyCode = 'd';
		break;
	case 9:		/* XV */
		info->KeyCode = FuncKeyClr;
		break;
	default:
		return;
	}
	butnum *= BUTTON_V;
	DrawSetLine(dbuf, butnum, 0, butnum + BUTTON_V - 1,
					BUTTON_V - 1, 3 + OptionXor, OptionFill);
	WindowDraw(Bwp, dbuf, 1);
	info->option = EventKey;
	WindowSendEvent(Bwp, info);
	DrawSetPut(dbuf, 0, 0, SendFlag? (&Mbars3Pattern):(&Mbarm3Pattern));
	WindowDraw(Bwp, dbuf, 1);
}

void
SetCDir(pos)
int	pos;
{
	if (MailNow)	SaveInf();

	strcpy(CDir, Env.Mailbox);
	strcat(CDir, dirdescend( DirList[pos]));
	strcat(CDir, "\\");
	if (!(SendFlag = SendCheck(DirList[pos]->name))) {
		TrashFlag = !strcmpi(DirList[pos]->name, "TRASH");
	}
	MailNow = 0;
	DirPos = pos;
	infupdate();
}

void
DirChange(wp, y, butterfly)
WindowID	wp;
int	y;
int	butterfly;
{
	if (!butterfly)	SetCDir(y);

	if (DirList[y]->flag == '+') {
		if (butterfly) {
			char	targetdir[128];
			strcpy(targetdir, Env.Mailbox);
			strcat(targetdir, dirdescend(DirList[y]));
			strcat(targetdir, "\\");
			butterfly = DIRGET(targetdir, DirList[y]);
		}else {
			butterfly = DIRGET(CDir, DirList[y]);
		}
	} else if (butterfly) {
		if (DirList[y]->flag == '-') {
			butterfly = closedir(y);
		} else {
			butterfly = FALSE;
		}
	}

	if (butterfly) {
		WindowClose(wp);
		WindowScrollOpen(0, 0 + BUTTON_V, 120, 244, Bwp, 120,
					(DirNow*FONT_V<=240)? 240:DirNow*FONT_V,
					DirectionY, 16, FONT_V, DirExec);
	} else {
		WindowRedraw(wp);
	}
}


int
DirExec(wp, info)
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[22 + 2], *dp = dbuf;
	char	buf[22][40];

	switch (info->option) {
	case EventOpen:
			WindowSetEventAttr(wp, EventAttrDefault);
		Dwp = wp;
		WindowRedraw(Dwp);
		return TRUE;

	case EventRedraw: {
		int	i, j, k, attr;

		if (DirNow < 20)	DrawSetClear(dp++, 1);
		i = HS_WindowGetHomeY(wp);
		if (DirCurPos < i || DirCurPos >= i + 20)	DirCurPos = i;
		if (i)	i -= 1;
		for (j = 0; i < DirNow && j < 22; i++, j++) {
			attr = (i == DirPos)? (AttrDefault ^ 8):AttrDefault;
			if (i == DirCurPos)	attr |= AttrUnderLine;
			k = FormatstringD(buf[j], DirList[i]);
			DrawSetSymbol(dp++, k, i * 12, buf[j], attr, 12);
		}
		WindowDraw(wp, dbuf, dp - dbuf);
		DrawSetPut(dp, 0, 0, SendFlag?(&Mbars3Pattern):(&Mbarm3Pattern));
		WindowDraw(Bwp, dp, 1);
		return TRUE;
	 }

	case EventClose:
		WindowClose(wp);
		Dwp = NULL;
		return TRUE;

	case EventMouseSwitch: {
		int	y = info->y / 12;

		if (!info->LeftON || y > DirNow)	return TRUE;
		DirCurPos = y;
		DirChange(wp, y, (DirList[y]->depth + 1) * 8 > info->x);
		return TRUE;
	 }
	}
	return FALSE;
}


int
MainExec(wp, info)
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[1];

	switch (info->option) {
	case EventOpen:
		Bwp = wp;
		WindowSetEventAttr(wp, EventAttrDefault);
		Dwp = NULL;
		strcpy(CDir, Env.Mailbox);
		if (DIRGET(CDir, NULL)) {;	/* xZbg */
			WindowRedraw(wp);
			WindowScrollOpen(0, 0 + BUTTON_V, 120, 244, wp, 120,
						(DirNow * FONT_V <= 240) ?240:DirNow*FONT_V,
						DirectionY, 16, FONT_V, DirExec);
			strcat(CDir, dirdescend(DirList[DirPos]));
			strcat(CDir, "\\");
			FILEGET();
			Mwp = WindowScrollOpen(120, 0 + BUTTON_V, 392, 244, wp, 392,
					(MailNow * FONT_V <= 240)? 240 : (MailNow * FONT_V),
					DirectionY, 16, FONT_V, MailExec);
		}else {
			ConsoleOpen();
			ConsolePrint("mview : [{bNXɃfBNg܂\n");
			quitop();
		}
		return TRUE;

	case EventRedraw:
		DrawSetClear(dbuf, 1);
		WindowDraw(wp, dbuf, 1);
		if (Dwp)	WindowRedraw(Dwp);
		if (Mwp)	WindowRedraw(Mwp);
		return TRUE;

	case EventClose:
		WindowClose(wp);
		quitop();
		return TRUE;

	case EventMouseSwitch:
		if (info->y <= BUTTON_V) {
			if (info->LeftON) {
				buttonop(wp, info);
				return TRUE;
			}
		} else if (info->y <= 244 + BUTTON_V) {
			info->y -= BUTTON_V;
			if (info->x <= 120) {
				return WindowSendEvent(Dwp, info);
			} else {
				info->x -= 120;
				return WindowSendEvent(Mwp, info);
			}
		}
		return FALSE;

	case EventKey:
		if (Dir) {
			return MainCont(wp, info);
		}else {
			return DirKey(Dwp, info);
		}

	case EventIconify:
		IconEnt(wp, "mview", AttrDefault|AttrHighLight, 16);
		return TRUE;
	}
	return FALSE;
}

void
mesprint(message)
char	*message;
{
	DrawBuf	dbuf[2];

	if (!Bwp)	return;

	DrawSetLine(dbuf, 0, 242 + 4 + BUTTON_V,
					511, 254 + 4 + BUTTON_V, 1, OptionFill);
	DrawSetSymbol(dbuf + 1, 0, 242 + 4 + BUTTON_V,
					message, AttrDefault, 12);
	WindowDraw(Bwp, dbuf, 2);
}
