/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: fstat.c,v 1.5 1994/11/26 15:06:37 mura Exp $
 */

/* System headers */
#define	__DOS_INLINE__
#include <sys/dos.h>


/* Functions */
int	fsize(char *filename)
{
	int ssp, result, fd;
	union _fcb *fcb;

	/* t@C I[v */
	fd = _dos_open(filename, 0);
	if (fd < -1)	return -1;

	/* X[p[oCU[[h */
	ssp = _dos_super(0);

	/* FCB ߂ */
	fcb = _dos_getfcb(fd);

	/* t@CTCYݒ */
	result = fcb->blk.size;

	/* ɖ߂ */
	if (ssp > 0)	_dos_super(ssp);

	/* t@C N[Y */
	_dos_close(fd);

	/* ʂԂ */
	return result;
}
