#include	"mview.h"
#include	"window.h"
#include	"mime.h"
/*#include	<stdlib.h>*/
#include	<io.h>
#include	<string.h>
#include	<doslib.h>

typedef	struct{
	FILE	*rfp;
	FILE	*wfp;
	char	TargetFile[128];
	char	RenameFile[128];
}	MIMESET;

static int	winlist(SUBINF*, char*, int, int);
static int	openmime(MIMESET*, char*);
static int	closemime(MIMESET*, int);


static int
winlist(inf, wild, attr, offset)
SUBINF	*inf;
char	*wild;
int	attr;
int	offset;
{
	int	subwinmax = MEMBER_MAX;
	int	FoundFile;
	char	endflag = FALSE;
	struct FILBUF	files_buffer;	/* files(fBNg)p */

	while (!endflag) {
		inf->WinMax = offset;
		if (!alloc_subwin(inf, subwinmax)) {
			return FALSE;
		}
		strcpy(inf->WinMember[inf->WinMax++].name, "蓮ݒ");
		strcpy(inf->WinMember[inf->WinMax++].name, "./ c̃fBNg");

		FoundFile = FILES(&files_buffer, wild, attr);
		while (1) {		/* A */
			if (FoundFile < 0) {
				endflag = TRUE;
				break;
			}
			if (inf->WinMax >= subwinmax) {
				subwinmax *= 2;
				break;
			}
			if (strcmp(files_buffer.name, "." )
					&& strcmp(files_buffer.name, "..")) {
				strcpy(inf->WinMember[inf->WinMax++].name, files_buffer.name);
			}
		 	FoundFile = NFILES(&files_buffer);
		}
	}
	return TRUE;
}


/* MIMEYt@\ */
void
MimeAdd(base)
WindowID	base;
{
	if (!SendFlag)	return;
	if (!(Mail[TargetNum].fileflag & M_CLIP)) {
		if (Env.Mimebox) {
			if (MimeManagerBox(Mail[TargetNum].filename, base)) {
				Mail[TargetNum].fileflag |= M_CLIP;
				SaveFlag = TRUE;
			}
		} else if (MimeManagerFree(Mail[TargetNum].filename)) {
				Mail[TargetNum].fileflag |= M_CLIP;
				SaveFlag = TRUE;
		}
		WindowRedraw(Mwp);
	}
}

static int
openmime(box, FileName)
MIMESET	*box;
char	*FileName;
{
	char	Temp[1024];

	/* ܂t@Cǂݏoɓŝ悢OɕςĂ܂ */
	strcpy(box->TargetFile, CDir);
	strcat(box->TargetFile, FileName);
	strcpy(box->RenameFile, CDir);
	strcat(box->RenameFile, "Temporary");

	if (rename(box->TargetFile, box->RenameFile) == -1) {
		mesprint("MIME: [𕡎ʂł܂");
		return FALSE;
	}

	if (!(box->rfp = fopen(box->RenameFile, "rt"))) {
		mesprint("MIME: ꎞt@Cǂ߂܂");
		return FALSE;
	}
	
	if (!(box->wfp = fopen(box->TargetFile, "wt"))) {
		mesprint("MIME: [쐬ł܂");
		fclose(box->rfp);
		return FALSE;
	}

	/* MIMEwb_̍ŌT */
	while (fgets822a(Temp, sizeof(Temp), box->rfp)) {
		fputs(Temp, box->wfp);
	}
	return TRUE;
}

static int
closemime(box, status)
MIMESET	*box;
int	status;
{
	char	Temp[256];

	if (status) {
		while (fgets(Temp, 256, box->rfp)) {
			fputs(Temp, box->wfp);
		}
	}
	fclose(box->rfp);
	fclose(box->wfp);

	/* ŌɃe| */
	if (remove(box->RenameFile) == -1) {
		mesprint("ꎞt@C폜ł܂");
		return FALSE;
	}
	return TRUE;
}

/* t@CX-Attachmentsǉ */
int
MimeManagerFree(FileName)
char *FileName;
{
	MIMESET	mymime;
	char Temp[256];

	if (!openmime(&mymime, FileName))	return FALSE;

	fputs("X-Attachment: \n\n", mymime.wfp);

	if (!closemime(&mymime, TRUE))	return FALSE;

	sprintf(Temp, "%s %s", Env.edopt, mymime.TargetFile);
	WindowLoadExec(Env.Med, Temp, NULL, NULL);

	return TRUE;
}

/* t@CX-Attachments+t@Cǉ */
int
MimeManagerBox(FileName, base)
char	*FileName;
WindowID	base;
{
	int	Ret;
	MIMESET	mymime;
	SUBINF	inf;
	char	TargetDir[256], Temp[256];

	inf.SubWinBase = base;

	/* mimeboxfBNg(1Kw) */
	strcpy(Temp, Env.Mimebox);
	strcat(Temp, "*.*");
	if (!winlist(&inf, Temp, 0x10, 2))	return FALSE;

	strcpy(inf.WinMember[0].name, "蓮ݒ");
	strcpy(inf.WinMember[1].name, "mimebox");

	Ret = WinManager(&inf, "Mime directory select", 0);
	strcpy(TargetDir, Env.Mimebox);
	if (Ret > 1) {
		/* TargetDir ɑIꂽfBNgZbg */
		strcat(TargetDir, inf.WinMember[Ret].name);
		strcat(TargetDir, "\\");
	}
	free_subwin(&inf);

	if (Ret < 0)	return FALSE;	/* LZ */
	if (!Ret)	return	MimeManagerFree(FileName);

	/* t@C */
	strcpy(Temp, TargetDir);
	strcat(Temp, "*.*");
	if (!winlist( &inf, Temp, 0x20, 0)) {
		free_subwin(&inf);
		return FALSE;
	}

	while (1) {
		if (WinManager(&inf, "Mime file select", 1) < 0) {
			free_subwin(&inf);
			return FALSE;	/* LZ */
		}
		/* 20ȏ̃}[N͑IׂȂ */
		if (inf.WinOnNum <= 20)	break;
		mesprint("Ytł̂20܂łł");
	}
	if (!inf.WinOnNum || !openmime(&mymime, FileName)) {
		free_subwin(&inf);
		return FALSE;	/* wȂ */
	} else {
		int	i, j;

		/* Yt(X-Attachment:)Zbg */
		for (i = 0, j = inf.WinOnNum; i < inf.WinMax; i++) {
			if (inf.WinMember[i].On) {
				fprintf(mymime.wfp, "X-Attachment: %s%s\n",
							TargetDir, inf.WinMember[i].name);
				if (!--j)	break;
			}
		}
		fputc('\n', mymime.wfp);
	}
	free_subwin(&inf);

	return closemime(&mymime, TRUE);
}

/* MIMEWJ@\ */
void	MimeExtract(MAILDATA *mail, char *dir)
{
	char	cmdline[256];

	if (Env.Mimebox) {
		sprintf(cmdline, "-b%s %s%s", Env.Mimebox, dir, mail->filename);
		WindowLoadExec("maish.x", cmdline, NULL, ConsoleChar);
	}
}
