* make text buffer for inside tview

RUNS_HUMAN_VERSION	equ	3
	.cpu 68000

* X68 GCC Develop

FOFF	equ	1024

BS	equ	08
TAB	equ	09
LF	equ	10
CR	equ	13

	.even
	.text

	.even
	.globl	_MakeBuf
_MakeBuf:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5,-(sp)
	move.l	4+8*4(sp),a5	*bp
	movem.l	(a5),a2/a3/a4	*bp->lp, str= bp->fbuf, bp->tabsize
	lea	FOFF(a2),a1	*ptr= bp->lp + FOFF
	move.l	a1,d5		*ptr
	add.l	8+8*4(sp),d5	*last= ptr + size
	moveq.l	#0,d4		*line
	movem.l	12(a5),d6/d7	*bp->tabmask, bp->maxcol
	lea	_nosjis(OPC),a0
	moveq.l	#0,d0
	bra	lp_ent
lp:
	moveq.l	#0,d1		*col= 0
	moveq.l	#-1,d3		*kanji= FALSE
	move.l	a3,(a2)+	* *lp++= str
	bra	line_ent
line_lp:
	move.b	(a1)+,d0	* *ptr
	cmpi.b	#' ',d0		*( ' ' < *ptr )?
	bcc	not_ctrl

	cmpi.b	#TAB,d0
	bne	not_tab

	move.l	d1,d2		*col
	and.l	d6,d2		*bp->tabmask
	sub.l	a4,d2		*bp->tabsize
	neg.l	d2		*l
	add.l	d2,d1		*col+= l
	bra	spclp_ent
spclp:
	move.b	#' ',(a3)+	* *str++= ' '
spclp_ent:
	dbra	d2,spclp	*l?
*	clr.w	d2		*64KBȏ̃^uݒ肷l
*	subq.l	#1,d2		*ȂƎv̂ŏȗ
*	bcc	spclp
	bra	line_ent
not_tab:
	cmpi.b	#CR,d0
	bne	not_cr

	move.b	(a1)+,d0	*ptr++
not_cr:
	cmp.b	#LF,d0
	beq	line_end

	cmpi.b	#BS,d0
	bne	line_ent

	tst.l	d1		*col == 0 ?
	beq	line_ent

	subq.w	#1,a3		*str--
	subq.l	#1,d1		*col--
	bra	line_ent
not_ctrl:
	tas	d3		*kanji ?
	beq	@f

	move.b	(a0,d0.w),d3	*nosjis[*ptr]
@@
	move.b	d0,(a3)+	* *str++= *ptr++
	addq.l	#1,d1		*col++
line_ent:
	cmp.l	d7,d1		*( bp->maxcol > col )?
	blt	line_lp
line_end:
	tst.b	d3		*kanji?
	bne	@f

	subq.w	#1,a3		*str--
	subq.w	#1,a1		*ptr--
@@
	clr.b	(a3)+		* *str++= NULL
	addq.l	#1,d4		*line++
lp_ent:
	cmp.l	a1,d5		*( ptr < last )?
	bhi	lp

	move.l	d4,20(a5)	*bp->line= line
	move.l	a3,d0		*str
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5
	rts

	.even
	.end
