/* mview.h */

#include	<corlib.h>

#ifndef	__stdio_h__
#include	<stdio.h>
#endif

#define		VERSION		"mview 0.70"

#define	__DOS_INLINE__

#define	BUFMAX	1024
#define	FILNMAX	128

#define		MAILMAX		256		/* [̏ől */
#define		STR_MAX		64		/* OȂǂ̍ől */
#define		DIRMAX		64		/* fBNg̏l */

#define		MSUBJECT_MAX	28	/* [薼pSTR_MAX */
#define		MNAME_MAX	20		/* [olp̂l`w */

#define		MAILLIST	"MLlist2.INF"	/* [Xgt@C */

#define		BUTTON_H	240		/* {^ */
#define		BUTTON_V	24		/* {^񍂂 */
#define		FONT_H		6		/* tHg */
#define		FONT_V		12		/* tHg */

#define	M_CHECK	0x01
#define	M_CLIP	0x02
#define	M_RES	0x04

/* O[oϐ */

typedef struct {					/* MAIL */
	char	title[MSUBJECT_MAX+1];	/* Subject */
	char	name[MNAME_MAX+1];		/* From(O) */
	char	year[11];				/* 쐬N() */
	char	time[9];				/* 쐬() */
	unsigned int	year_v;			/* 쐬N(l) */
	unsigned int	time_v;			/* 쐬(l) */
	char	fileflag;				/* ABCD A:---
											B:X?
											C:NbvAȂ
											D:M^
									*/
	char	type;					/* 0=fBNg  1=t@C */
	char	filename[22];			/* t@Cl[ */
} MAILDATA;

MAILDATA	*Mail;

char	*MailOn,				/* }[N */

		CDir[92],				/* ڃfBNg */
		Dir,					/* L[{[hΏ */

		SendFlag,				/* SENDnfBNgǂ */
		TrashFlag;				/* TRASHnfBNgǂ */
char	SaveFlag;				/* [񂪏ւꂽH */

int	MailNow,					/* [ */
	MarkNum,					/* }[N */
	TargetNum;					/* ڕWʒu */

						/* MVIEW.RC */
struct	EnvData {
	char	FilePutFlag;		/* [̐f[^ǂ */
	char	resolve;
	char	SeekFlag;			/* FirstSeek@\ */
	char	sort;				/* [ꗗ\[g 0: , 1: ~ */
	int	SmailNow;				/* smailIvV` */
	int	SignatureNow;			/* I` */
	int	AutoMoveNow;			/* U蕪` */
	char	*pack;				/* ݒGA|C^ */
	char	*Mailbox;			/* mailbox fBNg */
	char	*Sentbox;			/* MσfBNg */
	char	*Mimebox;			/* mimebox fBNg */
	char	*tempbox;			/* e|fBNg */
	char	*Med;				/* GfB^ */
	char	*edopt;				/* GfB^IvV */
	char	*Reply;				/* default reply */
	char	*Cc;				/* default Cc */
	char	*xcc;				/* cc 珜OAhX */
	char	*DefSubject;		/* ftHg^Cg */
	char	*Qmark;				/* pL */
	char	*replyhead;			/* p */
	char	*(*defconverter)(char*, char*);	/* default charset */
	char	*SmailName[16];		/* smail option ` */
	char	*SmailOption[16];	/* smail option */
	char	*SignatureName[16];	/* Ip */
	char	*SignatureFile[16];	/* t@C */
	char	*AutoMove[16];		/* U蕪p */
} Env;

WindowID	Bwp, Dwp, Mwp;		/* Ko-window EBhEID */


/* ֐vg^Cv */
								/* key.c */
									/* L[{[h */
int	MainCont(WindowID, EventInfo*);

								/* mailinf.c */
void	FILEGET();					/* [擾 */
void	MakeInf();					/* VK[擾 */
void	SaveInf();					/* [ۑ */
									/* [l[擾 */
char	*GetNewName(char*, MAILDATA*);

								/* makemail.c */
									/* [{؂o */
int	MakeViewFile(char*, MAILDATA*, FILE*, char*);
void	ReadMail();					/* rAN */
void	EditMail();					/* GfB^qvZXN */
									/* ԐM[쐬 */
void	ResMail(MAILDATA*, char*, int, WindowID);
									/* VK[쐬 */
void	WriteMail(MAILDATA*, char*, WindowID);

								/* func.c */
									/* [ʖۑ */
void	copymail(MAILDATA *mail, char *filename, WindowID base);
void	allmark();					/* S}[N/NA */
void	readmark();					/* ܂Ƃ߂Ċǃ}[N */
void	quitop();					/* I */
void	receive();					/* M */
void	transmit(WindowID);			/* M */
void	transmit_all(WindowID);		/* SM */
void	delop(int);					/* [폜 */
void	infupdate();				/* XV */
									/* \[g */
void	mailsort(char *filename, MAILDATA *mail, int mailnum);
void	AutoMove();					/* U蕪 */

								/* move.c */
void	rewriteinf(int mailnum);	/* [t@CXV */
void	moveop(WindowID);			/* [ړ */
void	Move(char*);				/* ړTu[` */
void	MoveManager(WindowID);		/* ړǗ[` */

								/* exec.c */
void	mesprint(char *mes);	/* EBhEXe[^X\ */

								/* form.s */
char	*CutStr2(char *str, int num);	/* ؂o() */
char	*GetKeyword(char *str, char *key);/* L[[hLFׂ */

								/* view.c */
int	BPopen(MAILDATA*, char*, int);	/* rAI[v */
void	viewinit(char*);			/* rAIvVݒ */

								/* fgets822a.c */
int	fgets822a(char *buf, int size, FILE *fp);	/* MIMEwb_pfgets */

								/* sub.c */
char	*jstrncpy(char *dest, char *src, int num);
void	extract_name(char *dest, char *src, int num);

								/* env.c */
int	GetEnvRc();						/* t@C ǂݍ */

int	fsize(char *filename);
int	pqsort(MAILDATA **mail, int mailnum);
